#!/usr/bin/python1.5
# Capturing Enemy Ships
#
# Version:
# 0.5 (beta; all functions implemented, but not yet fully working or buggy)
#
# TODO:
# -get the scan window also in the 1st-person-mode
#
# HISTORY:
# 30.1.2004:
# Defiant:      -got user output (without sound of course :( -using a dummy .wav file. Maybe we can have a better version in the future)
# 29.1.2004:
# Defiant:      -some fixes and addons for the Scan output. It also has a timer now.
#               -fixed Troops recall function
# 18.1.2004:
# Defiant:	-writing this history :)
#		-finished Scan Button
# 17.1.2004
# Defiant:	-Starting work on scan-buttons
#		-writing Rescue()
#
# older Stuff:
# 5. Defiant (Marines v0.4): Complete Rewrote: A new Marine Model.			 	        # Mod Liscense: GPL
#     code left from others:
#	- Banbury: Distance()
# 4. Defiant (Marines v0.3):		Merge Code from latest Transporter.py to Marines.py
# 3. Lord_Apophis (Marines v0-1 - v0.2):	Rewrote: Allow Beaming to Enemys (Marines.py)		# Mod Liscense: GPL
# 2. Defiant (Engineering Extension 0.1): 	Rewrote for Engineering Mod, will Transport to Target	# Mod Liscense: GPL
# 1. Banbury (QBR 2.2):		wrote the first Emergency Transporter for his QBR		        # Mod Liscense: GPL
#
# This script is using some code from the ReturnShuttles Mod (Liscense: GNU/GPL), Selft Destruct Countdown (SDK Liscense)
# and Shuttle Launching Framework(GPL)
#
# for the GNU GPL see http://www.gnu.org/copyleft
# and LGPL: http://www.gnu.org/copyleft/lesser.html
#
# current Maintainer:
# Defiant <mail@defiant.homedns.org>
# For updates see http://defiant.homedns.org/~erik/STBC/Marines/
#

import App
import MissionLib
import Bridge.BridgeUtils
import Lib.Ambiguity
import QuickBattle.QuickBattle
import ftb.ShipManager

pBridge = App.g_kSetManager.GetSet('bridge')
g_pBrex = App.CharacterClass_GetObject(pBridge, 'Engineer')
pBrexMenu = Bridge.BridgeUtils.GetBridgeMenu('Engineer')
g_pScience = App.CharacterClass_GetObject(pBridge, "Science") 
pScienceMenu = Bridge.BridgeUtils.GetBridgeMenu("Science") 
ET_CAPTURE		= App.Mission_GetNextEventType()
SELECT_TROOPS		= App.Mission_GetNextEventType()
MARINES_FIGHT_TIMER	= App.Mission_GetNextEventType()
RECALL_TROOPS		= App.Mission_GetNextEventType()
TRANSFER_TROOPS		= App.Mission_GetNextEventType()
TRANSFER_GET		= App.Mission_GetNextEventType()
TRANSFER_SHIELDON_TIMER = App.Mission_GetNextEventType()
RESCUE_ALL		= App.Mission_GetNextEventType()
SCAN_TIMER              = App.Mission_GetNextEventType()
EVENT_SCAN_TARGET       = None
pSound = App.TGSound_Create("sfx/Interface/new_game3.wav", "Beam_Sound", 0) # the Beam Sound
pSound.SetSFX(0)
pSound.SetInterface(1)
g_pDatabase = App.g_kLocalizationManager.Load("data/TGL/Bridge Crew General.tgl")
c_pTroops = 0
p_MaxTroops = 0
p_ActiveTroops = 0
ShieldTurnOnShip = 0
dist = 300 # Max Beam Distance
pGame_old = str(App.Game_GetCurrentGame()) # we need that one in restart()
dict_Marines = {} # dictionaries
dict_Battles = {}
pSciencePane = None
pScienceScanWindow = None
MarinesDatabase = App.g_kLocalizationManager.Load("data/TGL/Marines.tgl")


def TransferTroops(pObject, pEvent):
        global dist, dict_Marines, p_ActiveTroops, g_pDatabase, TRANSFER_SHIELDON_TIMER, ShieldTurnOnShip
        
        pGame = App.Game_GetCurrentGame()
        pEpisode = pGame.GetCurrentEpisode()
        pMission = pEpisode.GetCurrentMission()
        pPlayer = MissionLib.GetPlayer()
        pTarget = App.ShipClass_Cast(pPlayer.GetTarget())
        pFriendlies = pMission.GetFriendlyGroup()
        
        # Test if we have a Target
        if not pTarget:
                MarinesSay("BrexNoTarget")
                return

        # Test Distance
        if (Distance(pTarget) > 300):
                MarinesSay("TargetTooFar")
                return

        # Test if our Target is friendly
        if not pFriendlies.IsNameInGroup(pTarget.GetName()):
                MarinesSay("NoTransfer")
                return
        
        if (p_ActiveTroops == 0):
                MarinesSay("NoTroopsSelected")
                return
                
        if not dict_Marines.has_key(str(pTarget)): # test if we already have this ship as Object
                dict_Marines[str(pTarget)] = Marineclass(pTarget)
        if not dict_Marines.has_key(str(pPlayer)): # same test for Player
                dict_Marines[str(pPlayer)] = Marineclass(pPlayer)
        
        dict_Marines[str(pPlayer)].SetMarines(dict_Marines[str(pPlayer)].GetMarines() - p_ActiveTroops)
        dict_Marines[str(pTarget)].SetMarines(dict_Marines[str(pTarget)].GetMarines() + p_ActiveTroops)
        
        # Play the sound and flicker Shields
        ftime1 = int(round(p_ActiveTroops / (pPlayer.GetHull().GetRadius() * 10)))
        ftime2 = int(round(p_ActiveTroops / (pTarget.GetHull().GetRadius() * 10)))
        if (ftime1 > ftime2): # We need the longer Interval
            ftime = ftime1
        else:
            ftime = ftime2

        if ( pPlayer.GetShields().IsOn() == 1 ):
                pSequence = App.TGSequence_Create()
                global g_pBrex
                pSequence.AppendAction(App.CharacterAction_Create(g_pBrex, App.CharacterAction.AT_SAY_LINE, "LoweringShields", None, 0, g_pDatabase)) # Brex
                pSequence.AppendAction(App.TGScriptAction_Create("Actions.ShipScriptActions", "FlickerShields", 0, ftime)) # old Ship
                pSequence.Play()
        
        if ( pTarget.GetShields().IsOn() == 1 ):
                ShieldTurnOnShip = str(pTarget.GetName())
                pTarget.GetShields().TurnOff()
    
                # Timer from Self Destruct:
                # Create an event - it's a thing that will call this function
                pTimerEvent = App.TGEvent_Create()
                pTimerEvent.SetEventType(TRANSFER_SHIELDON_TIMER)
                pTimerEvent.SetDestination(App.TopWindow_GetTopWindow())

                # Create a timer - it's a thing that will wait for a given time,then do something
                pTimer = App.TGTimer_Create()
                pTimer.SetTimerStart(App.g_kUtopiaModule.GetGameTime() + ftime + 2)
                pTimer.SetDelay(0)
                pTimer.SetDuration(0)
                pTimer.SetEvent(pTimerEvent)
                App.g_kTimerManager.AddTimer(pTimer)
        App.g_kSoundManager.PlaySound("Beam_Sound")

        # reset the Troops Button:
        resetTroopsButton(dict_Marines[str(pPlayer)].GetMarines(), p_ActiveTroops)

def Rescue(pObject, pEvent):
        global dist, dict_Marines, p_ActiveTroops, g_pDatabase
        
        pGame = App.Game_GetCurrentGame()
        pEpisode = pGame.GetCurrentEpisode()
        pMission = pEpisode.GetCurrentMission()
        pPlayer = MissionLib.GetPlayer()
        pTarget = App.ShipClass_Cast(pPlayer.GetTarget())
        pFriendlies = pMission.GetFriendlyGroup()
    
        # Test if we have a Target
        if not pTarget:
                MarinesSay("BrexNoTarget")
                return

        # Test Distance
        if (Distance(pTarget) > 300):
                MarinesSay("TargetTooFar")
                return

        # Test if our Target is friendly
        if not pFriendlies.IsNameInGroup(pTarget.GetName()):
                MarinesSay("NoTransfer")
                return
        
        # Test if our Target is really that damaged:
        if (pTarget.GetHull().GetConditionPercentage() > 0.3 and pTarget.GetPowerSubsystem().GetConditionPercentage() > 0.4):
                MarinesSay("NoRescue")
                return
        
        if not dict_Marines.has_key(str(pTarget)): # test if we already have this ship as Object
                dict_Marines[str(pTarget)] = Marineclass(pTarget)
        if not dict_Marines.has_key(str(pPlayer)): # same test for Player
                dict_Marines[str(pPlayer)] = Marineclass(pPlayer)
        
        # Get the Beam time
        ftime = int(round((dict_Marines[str(pTarget)].GetMarines() + dict_Marines[str(pTarget)].GetPeople()) / (pPlayer.GetHull().GetRadius() * 10)))
   
        dict_Marines[str(pPlayer)].SetMarines(dict_Marines[str(pPlayer)].GetMarines() + dict_Marines[str(pTarget)].GetMarines())
        dict_Marines[str(pTarget)].SetMarines(0)
        dict_Marines[str(pPlayer)].SetPeople(dict_Marines[str(pPlayer)].GetPeople() + dict_Marines[str(pTarget)].GetPeople())
        dict_Marines[str(pTarget)].SetPeople(0)
        
        if ( pPlayer.GetShields().IsOn() == 1 ):
                pSequence = App.TGSequence_Create()
                global g_pBrex
                pSequence.AppendAction(App.CharacterAction_Create(g_pBrex, App.CharacterAction.AT_SAY_LINE, "LoweringShields", None, 0, g_pDatabase)) # Brex
                pSequence.AppendAction(App.TGScriptAction_Create("Actions.ShipScriptActions", "FlickerShields", 0, ftime)) # old Ship
                pSequence.Play()
        
        if ( pTarget.GetShields().IsOn() == 1 ):
                ShieldTurnOnShip = str(pTarget.GetName())
                pTarget.GetShields().TurnOff()
                # No, we don't turn the Shields on again
        App.g_kSoundManager.PlaySound("Beam_Sound")

        # No one on board:
        import AI.Player.Stay
        pTarget.SetAI(AI.Player.Stay.CreateAI(pTarget))
        
        # reset the Troops Button:
        resetTroopsButton(dict_Marines[str(pPlayer)].GetMarines(), p_ActiveTroops)


def TransferGet(pObject, pEvent):
        global dist, dict_Marines, p_ActiveTroops, g_pDatabase
        
        pGame = App.Game_GetCurrentGame()
        pEpisode = pGame.GetCurrentEpisode()
        pMission = pEpisode.GetCurrentMission()
        pPlayer = MissionLib.GetPlayer()
        pTarget = App.ShipClass_Cast(pPlayer.GetTarget())
        pFriendlies = pMission.GetFriendlyGroup()
    
        # Test if we have a Target
        if not pTarget:
                MarinesSay("BrexNoTarget")
                return

        # Test Distance
        if (Distance(pTarget) > 300):
                MarinesSay("TargetTooFar")
                return

        # Test if our Target is friendly
        if not pFriendlies.IsNameInGroup(pTarget.GetName()):
                MarinesSay("NoTransfer")
                return
                
        if not dict_Marines.has_key(str(pTarget)): # test if we already have this ship as Object
                dict_Marines[str(pTarget)] = Marineclass(pTarget)
        if not dict_Marines.has_key(str(pPlayer)): # same test for Player
                dict_Marines[str(pPlayer)] = Marineclass(pPlayer)
        
        MarinesFromOtherShip = int(dict_Marines[str(pTarget)].GetMarines() * (float(2)/3)) # can give us 2/3 of total Marines
        dict_Marines[str(pPlayer)].SetMarines(dict_Marines[str(pPlayer)].GetMarines() + MarinesFromOtherShip)
        dict_Marines[str(pTarget)].SetMarines(dict_Marines[str(pTarget)].GetMarines() - MarinesFromOtherShip)
        
        # Play the sound and flicker Shields
        ftime1 = int(round(MarinesFromOtherShip / (pPlayer.GetHull().GetRadius() * 10)))
        ftime2 = int(round(MarinesFromOtherShip / (pTarget.GetHull().GetRadius() * 10)))
        if (ftime1 > ftime2): # We need the longer Interval
            ftime = ftime1
        else:
            ftime = ftime2
        
        if ( pPlayer.GetShields().IsOn() == 1 ):
                pSequence = App.TGSequence_Create()
                global g_pBrex
                pSequence.AppendAction(App.CharacterAction_Create(g_pBrex, App.CharacterAction.AT_SAY_LINE, "LoweringShields", None, 0, g_pDatabase)) # Brex
                pSequence.AppendAction(App.TGScriptAction_Create("Actions.ShipScriptActions", "FlickerShields", 0, ftime)) # old Ship
                pSequence.Play()
        
        if ( pTarget.GetShields().IsOn() == 1 ):
                ShieldTurnOnShip = str(pTarget.GetName())
                pTarget.GetShields().TurnOff()
    
                # Timer from Self Destruct:
                # Create an event - it's a thing that will call this function
                pTimerEvent = App.TGEvent_Create()
                pTimerEvent.SetEventType(TRANSFER_SHIELDON_TIMER)
                pTimerEvent.SetDestination(App.TopWindow_GetTopWindow())

                # Create a timer - it's a thing that will wait for a given time,then do something
                pTimer = App.TGTimer_Create()
                pTimer.SetTimerStart(App.g_kUtopiaModule.GetGameTime() + ftime + 2)
                pTimer.SetDelay(0)
                pTimer.SetDuration(0)
                pTimer.SetEvent(pTimerEvent)
                App.g_kTimerManager.AddTimer(pTimer)
        App.g_kSoundManager.PlaySound("Beam_Sound")

        # reset the Troops Button:
        resetTroopsButton(dict_Marines[str(pPlayer)].GetMarines(), p_ActiveTroops)


def TransferShieldsOn(pObject, pEvent):
    global ShieldTurnOnShip
    
    pPlayer = MissionLib.GetPlayer()
    pTarget = App.ShipClass_Cast(pPlayer.GetTarget())
    
    if (ShieldTurnOnShip == str(pTarget.GetName()) and pTarget.GetShields().IsOn() != 1):
        pTarget.GetShields().TurnOn()


def RecallTroops(pObject, pEvent):
        global dict_Marines, dist, pSound, dict_Battles, g_pDatabase
        
        pPlayer = MissionLib.GetPlayer()
        pTarget = App.ShipClass_Cast(pPlayer.GetTarget())
        
        if not pTarget:
                MarinesSay("BrexNoTarget")
                return
                
        if (Distance(pTarget) > dist):
                MarinesSay("TargetTooFar")
                return

        # try to find an offline Shield
        OfflineShield = -1        
        for Shield in range(App.ShieldClass.NUM_SHIELDS):
                if (pTarget.GetShields().GetCurShields(Shield) < 200):
                        OfflineShield = Shield
        if (OfflineShield == -1):
                        MarinesSay("NoOfflineShield")
                        for Shield in range(App.ShieldClass.NUM_SHIELDS):
                            print (Shield, pTarget.GetShields().GetCurShields(Shield))
                        return
                        
        if not dict_Marines.has_key(str(pTarget)): # test if we already have this ship as Object
                dict_Marines[str(pTarget)] = Marineclass(pTarget)
        
        OurMarinesOnShip = dict_Marines[str(pTarget)].GetEnemyMarinesOnShip()
        if (OurMarinesOnShip == 0):
            MarinesSay("NoMarinesOnTarget")
            return
        
        # else Beaming:
        dict_Marines[str(pPlayer)].SetMarines(dict_Marines[str(pPlayer)].GetMarines() + OurMarinesOnShip)
        # and 0 friendly Marines on enemy Ship:
        dict_Marines[str(pTarget)].SetEnemyMarinesOnShip(0)
        
        # Delete old Attack
        i = 0
        list = dict_Battles.values()
        while (i != len(dict_Battles)):
            if (str(list[i][3]) == str(pTarget)): # we are trying to find our attack Groups by comparing the Target field with our Target
                dict_Battles[dict_Battles.keys()[i]] = (0, 0, 0, 0, 0)
            i = i + 1
        
        # Play the sound and flicker Shields
        ftime = (OurMarinesOnShip / (pPlayer.GetHull().GetRadius() * 10))
        print ("Troops need seconds:", ftime)

        if ( pPlayer.GetShields().IsOn() == 1 ):
                pSequence = App.TGSequence_Create()
                pSequence.AppendAction(App.CharacterAction_Create(g_pBrex, App.CharacterAction.AT_SAY_LINE, "LoweringShields", None, 0, g_pDatabase)) # Brex
                pSequence.AppendAction(App.TGScriptAction_Create("Actions.ShipScriptActions", "FlickerShields", 0, ftime)) # old Ship
                pSequence.Play()
        App.g_kSoundManager.PlaySound("Beam_Sound")

        # rest the Troops Button:
        resetTroopsButton(dict_Marines[str(pPlayer)].GetMarines(), 0)


def Capture(pObject, pEvent):
        global p_ActiveTroops, dist, pSound, g_pDatabase

        pPlayer = MissionLib.GetPlayer()
        pTarget = pPlayer.GetTarget()
        pSet = pPlayer.GetContainingSet()
        pGame = App.Game_GetCurrentGame()
        pEpisode = pGame.GetCurrentEpisode()
        pMission = pEpisode.GetCurrentMission()
        pEnemies = pMission.GetEnemyGroup()
        pFriendlies = pMission.GetFriendlyGroup()
        pClosest = None
        lpEnemies = pEnemies.GetActiveObjectTupleInSet(pSet)
        pTargetattr = App.ShipClass_Cast(pTarget)
        
        if not pTarget:
                MarinesSay("BrexNoTarget")
                return
                
        if (Distance(pTarget) > dist):
                MarinesSay("TargetTooFar")
                return

        if (pFriendlies.IsNameInGroup(pTarget.GetName()) == 1):
                MarinesSay("BrexTargetFriendly")
                return
        
        if (p_ActiveTroops == 0):
                MarinesSay("NoTroopsSelected")
                return

        # try to find an offline Shield
        OfflineShield = -1        
        for Shield in range(App.ShieldClass.NUM_SHIELDS):
                if (pTargetattr.GetShields().GetCurShields(Shield) < 200):
                        OfflineShield = Shield
        if (OfflineShield == -1):
                        MarinesSay("NoOfflineShield")
                        for Shield in range(App.ShieldClass.NUM_SHIELDS):
                            print (Shield, pTargetattr.GetShields().GetCurShields(Shield))
                        return
                  
        EnemyPeople = GetNumPeople(pTargetattr)
        EnemyPeople = EnemyPeople + GetNumMarines(pTargetattr) # do it in two steps, else would create the Object two times
        pTargetSubsystem = pPlayer.GetTargetSubsystem()
                
        # Play the sound and flicker Shields
        ftime = (p_ActiveTroops / (pPlayer.GetHull().GetRadius() * 10))
        MarinesSay("ShieldDowntime", ftime)
        
        pSequence = App.TGSequence_Create()
        if ( pPlayer.GetShields().IsOn() == 1 ):
                pSequence.AppendAction(App.CharacterAction_Create(g_pBrex, App.CharacterAction.AT_SAY_LINE, "LoweringShields", None, 0, g_pDatabase)) # Brex
                pSequence.AppendAction(App.TGScriptAction_Create("Actions.ShipScriptActions", "FlickerShields", 0, ftime)) # old Ship
        pSequence.Play()
        App.g_kSoundManager.PlaySound("Beam_Sound")
        
        # Fight here
        FightBattle(pPlayer, p_ActiveTroops, EnemyPeople, App.ShipClass_Cast(pTarget), pTargetSubsystem)


def FightBattle(pShip, PlayerMarines, EnemyMarines, pTarget, pTargetSubsystem):
        global dict_Marines, p_ActiveTroops, MARINES_FIGHT_TIMER, dict_Battles

        # 1. decrease Players Marine Number:
        dict_Marines[str(pShip)].SetMarines(dict_Marines[str(pShip)].GetMarines()- PlayerMarines)
        if (dict_Marines[str(pShip)].GetMarines() <= p_ActiveTroops):
                p_ActiveTroops = dict_Marines[str(pShip)].GetMarines()
        
        # 2. Marines arrived:
        dict_Marines[str(pTarget)].SetEnemyMarinesOnShip(dict_Marines[str(pTarget)].GetEnemyMarinesOnShip() + p_ActiveTroops)
        
        # rest the Troops Button:
        resetTroopsButton(dict_Marines[str(pShip)].GetMarines(), p_ActiveTroops - 1)
        
	# Create an event - it's a thing that will call this function
	pTimerEvent = App.TGEvent_Create()
	pTimerEvent.SetEventType(MARINES_FIGHT_TIMER)
	pTimerEvent.SetDestination(App.TopWindow_GetTopWindow())

        if (pTargetSubsystem.GetName() == pTarget.GetHull().GetName()):
                # If we are trying to capture, we need at least 40s and up to 2min
                CounterTime = 40 + App.g_kSystemWrapper.GetRandomNumber(80)
        else:
                # something between 10 and 20 seconds
                CounterTime = 10 + App.g_kSystemWrapper.GetRandomNumber(10)
        
        print ("Troops need seconds:", CounterTime)
        
        EndBattleTime = App.g_kUtopiaModule.GetGameTime() + CounterTime

	# Create a timer - it's a thing that will wait for a given time,then do something
	pTimer = App.TGTimer_Create()
	pTimer.SetTimerStart(EndBattleTime)
	pTimer.SetDelay(0)
	pTimer.SetDuration(0)
	pTimer.SetEvent(pTimerEvent)
	App.g_kTimerManager.AddTimer(pTimer)

        dict_Battles[str(int(EndBattleTime * 100))] = (pShip, PlayerMarines, EnemyMarines, pTarget, pTargetSubsystem)


def resetTroopsButton(max_Marines, p_ActiveTroops2):
        global pButtonSelectTroops, p_ActiveTroops
        p_ActiveTroops = p_ActiveTroops2
        if (p_ActiveTroops < max_Marines):
            p_ActiveTroops = 0
        pButtonSelectTroops.SetName(App.TGString('Troops(Max:' + str(max_Marines) + '): ' + str(p_ActiveTroops)))

    
def EndBattle(pObject, pEvent):
        global dict_Marines, p_ActiveTroops, dict_Battles
        
        GameTime = int(App.g_kUtopiaModule.GetGameTime()*100)
        if not dict_Battles.has_key(str(GameTime)):
            GameTime = GameTime - 1
        if not dict_Battles.has_key(str(GameTime)): # FIXME - what to do if the time is real bad?
            print("Something went wrong with dictionary dict_Battles...Marines lost.")
            return
            
        if (dict_Battles[str(GameTime)][0] == 0):
            print("Attack was stopped")
            return
        pShip                   = dict_Battles[str(GameTime)][0]
        PlayerMarines           = dict_Battles[str(GameTime)][1]
        EnemyMarines            = dict_Battles[str(GameTime)][2]
        pTarget                 = dict_Battles[str(GameTime)][3]
        pTargetSubsystem        = dict_Battles[str(GameTime)][4]
        
        pGame = App.Game_GetCurrentGame()
        pEpisode = pGame.GetCurrentEpisode()
        pMission = pEpisode.GetCurrentMission()
        pFriendlies = pMission.GetFriendlyGroup()
        pEnemies = pMission.GetEnemyGroup()
        pTargetattr = pTarget # it is already a shipclass cast!
        
        # Make sure that Target is really ennemy
        if not pEnemies.IsNameInGroup(pTarget.GetName()):
            # Stop the Attack
            i = 0
            list = dict_Battles.values()
            while (i != len(dict_Battles)):
                if (str(list[i][3]) == str(pTarget)): # we are trying to find our attack Groups by comparing the Target field with our Target
                        dict_Battles[dict_Battles.keys()[i]] = (0, 0, 0, 0, 0)
                i = i + 1
            # Add our attack crew to the Ship ones.
            dict_Marines[str(pTarget)].SetMarines(PlayerMarines )
            return
            
        
        if (pTargetSubsystem.GetName() == pTargetattr.GetHull().GetName()):
                #print("Trying to capture the Ship")
                cWin    = int(float(PlayerMarines) / EnemyMarines * 100) # One Number has to be float, result int
                cRandom = App.g_kSystemWrapper.GetRandomNumber(100)
                if (cRandom > cWin):
                        MarinesSay("MarinesLostCapture", "Felix")
                        return
                else:
                        MarinesSay("MarinesWonCapture", "Felix")
                        # so we won the fight - make Target friendly:
                        if pEnemies.IsNameInGroup(pTarget.GetName()):
                                pEnemies.RemoveName(pTarget.GetName())
                        # If this is the last Ship, there can be a Problem with the Enemy Group, so add a dummy
                        if not pEnemies.GetNameTuple():
                                pEnemies.AddName("nothing")
                        # Finaly captured!
                        pFriendlies.AddName(pTarget.GetName())
                        MarinesSetFriendlyAI(pTarget)
                        # But they don't have any Marines
                        dict_Marines[str(pTarget)].SetMarines(0)
                        dict_Marines[str(pTarget)].SetPeople(PlayerMarines) # and the capturing Marines are the crew now
                        return
        else:
            #print("Target is a subsystem...trying to damage:")
            PeopleInSubsystem = int(pTargetSubsystem.GetRadius() * 100 * (pTargetSubsystem.GetMaxCondition() / pTargetSubsystem.GetCondition()))
            cWin    = int(float(PlayerMarines) / PeopleInSubsystem * 100) # One Number has to be float, result int
            cRandom = App.g_kSystemWrapper.GetRandomNumber(100)
            if (cRandom < cWin):
                MarinesSay("MarinesLostCapture", "Felix")
                return
            else:
                # some calculations...
                tDamage = pTargetSubsystem.GetCondition() - pTargetSubsystem.GetMaxCondition() * (App.g_kSystemWrapper.GetRandomNumber(cRandom - cWin)) / 100
                if (tDamage < 1): # Protection: We don't want a System with HP <0
                        pTarget.DestroySystem(pTargetSubsystem)
                else:
                        pTargetSubsystem.SetCondition(tDamage)
                PlayerMarinesLoosing = int(PlayerMarines / float(cRandom - cWin))
                BeamBack(PlayerMarines - PlayerMarinesLoosing, pTarget)
                
                EnemyMarinesLoosing = int(PeopleInSubsystem * App.g_kSystemWrapper.GetRandomNumber(cRandom - cWin)) / 100
                
                EnemyPeopleLoosing = int(float(dict_Marines[str(pTargetattr)].GetPeople()) / dict_Marines[str(pTargetattr)].GetMarines() * EnemyMarinesLoosing)
                dict_Marines[str(pTargetattr)].SetMarines(dict_Marines[str(pTargetattr)].GetMarines() - EnemyMarinesLoosing)
                dict_Marines[str(pTargetattr)].SetPeople(dict_Marines[str(pTargetattr)].GetPeople() - EnemyPeopleLoosing)
                
                return


def BeamBack(PlayerMarines, pTarget):
        global dict_Marines, dist, pSound, g_pDatabase
        pPlayer = MissionLib.GetPlayer()
        pTargetattr = pTarget # yes - it is the same
        
        # Shields have to be still offline
        OfflineShield = -1        
        for Shield in range(App.ShieldClass.NUM_SHIELDS):
                if (pTargetattr.GetShields().GetCurShields(Shield) < 200):
                        OfflineShield = Shield
        if (OfflineShield == -1 or Distance(pTarget) > dist):
                        print ("No offline Shield or Distance to high: can't save Troops...Troops are now trying to capture Ship")
                        for Shield in range(App.ShieldClass.NUM_SHIELDS):
                            print (Shield, pTargetattr.GetShields().GetCurShields(Shield))
                            EnemyPeople = GetNumPeople(pTarget) + GetNumMarines(pTarget)
                            FightBattle(pPlayer, PlayerMarines, EnemyPeople, pTarget, pTarget.GetHull())
                        return
                
        ftime = (PlayerMarines / (pPlayer.GetHull().GetRadius() * 10))
        pSequence = App.TGSequence_Create()
        if ( pPlayer.GetShields().IsOn() == 1 ):
                pSequence.AppendAction(App.CharacterAction_Create(g_pBrex, App.CharacterAction.AT_SAY_LINE, "LoweringShields", None, 0, g_pDatabase)) # Brex
                pSequence.AppendAction(App.TGScriptAction_Create("Actions.ShipScriptActions", "FlickerShields", 0, ftime)) # old Ship
        pSequence.Play()
        App.g_kSoundManager.PlaySound("Beam_Sound")
        
        # increase our Marines number
        dict_Marines[str(pPlayer)].SetMarines(dict_Marines[str(pPlayer)].GetMarines()+ PlayerMarines)
        # and 0 friendly Marines on enemy Ship:
        dict_Marines[str(pTarget)].SetEnemyMarinesOnShip(0)
    

# captuered..reset AI
def MarinesSetFriendlyAI(pTarget):
	import QuickBattle.QuickBattle
	import Custom.QuickBattleGame.QuickBattle

        pTargetattr = pTarget # same here - pTarget is already a cast
        # set AI
        # We need to know if we are playing normal QB or QBR:
        # QB
        if QuickBattle.QuickBattle.pFriendlies:
                if (pTargetattr.GetShipProperty().IsStationary() == 1):
                        # its a Station
                        import QuickBattle.StarbaseFriendlyAI
                        pTargetattr.SetAI(QuickBattle.StarbaseFriendlyAI.CreateAI(pTargetattr))
                else:
                        import QuickBattle.QuickBattleFriendlyAI
                        pTargetattr.SetAI(QuickBattle.QuickBattleFriendlyAI.CreateAI(pTargetattr))
        # QBR
        elif Custom.QuickBattleGame.QuickBattle.pFriendlies:
                if (pTargetattr.GetShipProperty().IsStationary() == 1):
                # its a Station
                        import Custom.QuickBattleGame.StarbaseFriendlyAI
                        pTargetattr.SetAI(Custom.QuickBattleGame.StarbaseFriendlyAI.CreateAI(pTargetattr))
                else:
                        import Custom.QuickBattleGame.QuickBattleFriendlyAI
                        pTargetattr.SetAI(Custom.QuickBattleGame.QuickBattleFriendlyAI.CreateAI(pTargetattr))


# change the Button
def SelectTroops(pObject, pEvent):
    global pButtonSelectTroops, c_pTroops, p_MaxTroops, p_ActiveTroops, dict_Marines
    
    pPlayer = MissionLib.GetPlayer()
    
    if not dict_Marines.has_key(str(pPlayer)):
        dict_Marines[str(pPlayer)] = Marineclass(pPlayer)
    p_MaxTroops = dict_Marines[str(pPlayer)].GetMarines()
    
    # If we start clicking from 0
    if (p_ActiveTroops == p_MaxTroops):
        p_ActiveTroops = 0
    elif (p_ActiveTroops + 5 > p_MaxTroops):
        p_ActiveTroops = p_MaxTroops
    elif (p_ActiveTroops < 5):
        p_ActiveTroops = 5
    else:
        p_ActiveTroops = p_ActiveTroops + 5
    
    pButtonSelectTroops.SetName(App.TGString('Troops(Max:' + str(p_MaxTroops) + '): ' + str(p_ActiveTroops)))
    

# Get the Distance between the Player and pObject - made by Banbury for QBR
def Distance(pObject):
	pPlayer = App.Game_GetCurrentPlayer()
	vDifference = pObject.GetWorldLocation()
	vDifference.Subtract(pPlayer.GetWorldLocation())

	return vDifference.Length()


# Actually from ReturnShuttles
def GetNumMarines(pShip):
        global dict_Marines
        
        if not dict_Marines.has_key(str(pShip)):
            dict_Marines[str(pShip)] = Marineclass(pShip)
        return dict_Marines[str(pShip)].GetMarines()


# same... from ReturnShuttles
def GetNumPeople(pShip):
        global dict_Marines
        
        if not dict_Marines.has_key(str(pShip)):
            dict_Marines[str(pShip)] = Marineclass(pShip)
        return dict_Marines[str(pShip)].GetPeople()


# Restart is called by Engineering Extension on ...well restart
def Restart():
    global pGame_old
    pGame = App.Game_GetCurrentGame()

    # test if the restart is only Called by ftb!
    if (str(pGame) == pGame_old):
        #print("Game havn't changed - return.")
        return
    pGame_old = str(pGame)
    
    global dict_Marines, pButtonSelectTroops, p_ActiveTroops, dict_Battles
    pPlayer = App.Game_GetCurrentPlayer()
    dict_Marines.clear()
    dict_Battles.clear()
    p_ActiveTroops = 0
    if not dict_Marines.has_key(str(pPlayer)):
            dict_Marines[str(pPlayer)] = Marineclass(pPlayer)
    pButtonSelectTroops.SetName(App.TGString('Troops(Max:' + str(dict_Marines[str(pPlayer)].GetMarines()) + '): ' + str(p_ActiveTroops)))
    



def ScanInit(pObject, pEvent):
        global SCAN_TIMER, EVENT_SCAN_TARGET, pScienceScanWindow
        
        EVENT_SCAN_TARGET = pEvent.GetInt()

        # clear the Science Pane
        if not pScienceScanWindow:
                CreateSciencePane()
        else:
                pScienceScanWindow.KillChildren()
        
        # Create an event - it's a thing that will call this function
	pTimerEvent = App.TGEvent_Create()
	pTimerEvent.SetEventType(SCAN_TIMER)
	pTimerEvent.SetDestination(App.TopWindow_GetTopWindow())

	CounterTime = 10.0
	
	# Create a timer - it's a thing that will wait for a given time,then do something
	pTimer = App.TGTimer_Create()
	pTimer.SetTimerStart(App.g_kUtopiaModule.GetGameTime() + CounterTime)
	pTimer.SetDelay(0)
	pTimer.SetDuration(0)
	pTimer.SetEvent(pTimerEvent)
	App.g_kTimerManager.AddTimer(pTimer)


def MarinesScan(pObject, pEvent):
        global dict_Marines, pScienceScanWindow, EVENT_SCAN_TARGET
    
        iType = EVENT_SCAN_TARGET

        pPlayer         = MissionLib.GetPlayer()
        pGame           = App.Game_GetCurrentGame()
        pShip           = App.ShipClass_Cast(pGame.GetPlayer())
        pSensors        = pShip.GetSensorSubsystem()
        pTarget         = App.ShipClass_Cast(pShip.GetTarget())
        pSet            = pPlayer.GetContainingSet()
        pEpisode	= pGame.GetCurrentEpisode()
        pMission	= pEpisode.GetCurrentMission()
        pEnemyGroup     = pMission.GetEnemyGroup()
        lpEnemys        = pEnemyGroup.GetActiveObjectTupleInSet(pSet)
        pFriendlyGroup  = pMission.GetFriendlyGroup()
        lpFriendlies    = pFriendlyGroup.GetActiveObjectTupleInSet(pSet)
        x2              = 0.2
        countWeapons    = 0

        if not pScienceScanWindow:
                CreateSciencePane()
        else:
                pScienceScanWindow.KillChildren()

        if (pEvent.GetSource()):
                if (App.ObjectClass_Cast(pEvent.GetSource())):
                        pTarget = App.ObjectClass_Cast(pEvent.GetSource())
        
        if (iType == App.CharacterClass.EST_SCAN_OBJECT):
                if (pTarget):
			pTractorText = App.TGParagraph_CreateW(App.TGString("Scanning Target:"))
                        pScienceScanWindow.AddChild(pTractorText, 0, 0, 0)
                        y = 0.02
                        pScienceScanWindow.AddChild(App.TGParagraph_CreateW(App.TGString("Shipname:")), 0, y, 0)
                        pScienceScanWindow.AddChild(App.TGParagraph_CreateW(App.TGString(str(pTarget.GetName()))), x2, y, 0)
                        y = y + 0.02
                        pScienceScanWindow.AddChild(App.TGParagraph_CreateW(App.TGString("Target:")), 0, y, 0)
                        if pTarget.GetTarget():
                                pScienceScanWindow.AddChild(App.TGParagraph_CreateW(App.TGString(str(pTarget.GetTarget().GetName()))), x2, y, 0)
                        else:
                                pScienceScanWindow.AddChild(App.TGParagraph_CreateW(App.TGString("None")), x2, y, 0)
                        y = y + 0.02
                        
                        # print critical Status
			HullStatus = int(pTarget.GetHull().GetCondition())
			pScienceScanWindow.AddChild(App.TGParagraph_CreateW(App.TGString("Hull Strength:")), 0, y, 0)
                        pScienceScanWindow.AddChild(App.TGParagraph_CreateW(App.TGString(str(HullStatus))), x2, y, 0)
			y = y + 0.02
                        
                        if not dict_Marines.has_key(str(pTarget)): # test if we already have this ship as Object
                                dict_Marines[str(pTarget)] = Marineclass(pTarget)
                        pScienceScanWindow.AddChild(App.TGParagraph_CreateW(App.TGString("total Crew:")), 0, y, 0)
                        pScienceScanWindow.AddChild(App.TGParagraph_CreateW(App.TGString(str(dict_Marines[str(pTarget)].GetPeople() + dict_Marines[str(pTarget)].GetMarines()))), x2, y, 0)
                        y = y + 0.02
                        # Cycle through the subsystems:
                        averageStatus = 0
			criticalStatus = 0
			count_critical = 0
                        pPropSet = pTarget.GetPropertySet()
                        pShipSubSystemPropInstanceList = pPropSet.GetPropertiesByType(App.CT_SUBSYSTEM_PROPERTY)
                        iNumItems = pShipSubSystemPropInstanceList.TGGetNumItems()
                        pShipSubSystemPropInstanceList.TGBeginIteration()
                        for i in range(iNumItems):
                                pInstance = pShipSubSystemPropInstanceList.TGGetNext()
                                pProperty = pTarget.GetSubsystemByProperty(App.SubsystemProperty_Cast(pInstance.GetProperty()))
                                # 1. Get Average Status of All Systems
                                averageStatus = averageStatus + pProperty.GetConditionPercentage()
                                # 2. Find critical Systems and get their Average
				if pProperty.IsCritical():
					criticalStatus = criticalStatus + pProperty.GetConditionPercentage()
					count_critical = count_critical + 1
				
				
                        pShipSubSystemPropInstanceList.TGDoneIterating()
                        pShipSubSystemPropInstanceList.TGDestroy()
			
			# print System Status
                        averageStatus = int((averageStatus / iNumItems)*100)
                        pScienceScanWindow.AddChild(App.TGParagraph_CreateW(App.TGString("average Status:")), 0, y, 0)
                        pScienceScanWindow.AddChild(App.TGParagraph_CreateW(App.TGString(str(averageStatus) + "%")), x2, y, 0)
                        y = y + 0.02
			
			# print critical Status
			criticalStatus = int((criticalStatus / count_critical)*100)
			pScienceScanWindow.AddChild(App.TGParagraph_CreateW(App.TGString("avg critival Status:")), 0, y, 0)
                        pScienceScanWindow.AddChild(App.TGParagraph_CreateW(App.TGString(str(criticalStatus) + "%")), x2, y, 0)
			y = y + 0.02
			
			# 3. The Weapons:
                        if pTarget.GetPhaserSystem():
                                WeaponStatus1 = pTarget.GetPhaserSystem().GetCombinedConditionPercentage()
                                countWeapons = countWeapons + 1
                        else:
                                WeaponStatus1 = 0
                        if pTarget.GetTorpedoSystem():
                                WeaponStatus2 = pTarget.GetTorpedoSystem().GetCombinedConditionPercentage()
                                countWeapons = countWeapons + 1
                        else:
                                WeaponStatus2 = 0
                        if pTarget.GetPulseWeaponSystem():
                                WeaponStatus3 = pTarget.GetPulseWeaponSystem().GetCombinedConditionPercentage()
                                countWeapons = countWeapons + 1
                        else:
                                WeaponStatus3 = 0
                        
                        if (countWeapons == 0):
                                WeaponStatus = 0
                        else:
                                WeaponStatus = int(((WeaponStatus1 + WeaponStatus2 + WeaponStatus3) / countWeapons)*100)
			pScienceScanWindow.AddChild(App.TGParagraph_CreateW(App.TGString("avg Weapon Status:")), 0, y, 0)
                        pScienceScanWindow.AddChild(App.TGParagraph_CreateW(App.TGString(str(WeaponStatus) + "%")), x2, y, 0)
			y = y + 0.02
                        
			# 4. Shields:
			pScienceScanWindow.AddChild(App.TGParagraph_CreateW(App.TGString("Shield Status:")), 0, y, 0)
                        if pTarget.GetShields():
			        for Shield in range(App.ShieldClass.NUM_SHIELDS):
				        pScienceScanWindow.AddChild(App.TGParagraph_CreateW(App.TGString(str(pTarget.GetShields().GetCurShields(Shield)))), x2, y, 0)
				        y = y + 0.02
                        else:
        			pScienceScanWindow.AddChild(App.TGParagraph_CreateW(App.TGString("None")), x2, y, 0)
                                y = y + 0.02

                        # Torpedos
                        pScienceScanWindow.AddChild(App.TGParagraph_CreateW(App.TGString("Torpedo counts:")), 0, y, 0)
                        if pTarget.GetTorpedoSystem():
                                TorpSubSys = pTarget.GetTorpedoSystem()
                                iNumTorpTypes = TorpSubSys.GetNumAmmoTypes()
                                for iType in range(iNumTorpTypes):
                                        pScienceScanWindow.AddChild(App.TGParagraph_CreateW(App.TGString(str(TorpSubSys.GetAmmoType(iType).GetAmmoName()) + ': ' + str(TorpSubSys.GetNumAvailableTorpsToType(iType)))), x2, y, 0)
                                        y = y + 0.02
                        else:
                                pScienceScanWindow.AddChild(App.TGParagraph_CreateW(App.TGString("None")), x2, y, 0)
                                y = y + 0.02

        if (iType == App.CharacterClass.EST_SCAN_AREA):
                pText = App.TGParagraph_CreateW(App.TGString("Scanning Area:"))
                pScienceScanWindow.AddChild(pText, 0, 0, 0)
                y = 0.02
                pScienceScanWindow.AddChild(App.TGParagraph_CreateW(App.TGString("Shipname:")), 0, y, 0)
                pScienceScanWindow.AddChild(App.TGParagraph_CreateW(App.TGString("Target:")), x2, y, 0)
                for pEnemy in lpEnemys:
                        y = y + 0.02
                        pScienceScanWindow.AddChild(App.TGParagraph_CreateW(App.TGString(str(pEnemy.GetName()) + ": ")), 0, y, 0)
                        if pEnemy.GetTarget():
                                pScienceScanWindow.AddChild(App.TGParagraph_CreateW(App.TGString(str(pEnemy.GetTarget().GetName()))), x2, y, 0)
                        else:
                                pScienceScanWindow.AddChild(App.TGParagraph_CreateW(App.TGString("None")), x2, y, 0)
                for pFriendly in lpFriendlies:
                        y = y + 0.02
                        pScienceScanWindow.AddChild(App.TGParagraph_CreateW(App.TGString(str(pFriendly.GetName()) + ": ")), 0, y, 0)
                        if pFriendly.GetTarget():
                                pScienceScanWindow.AddChild(App.TGParagraph_CreateW(App.TGString(str(pFriendly.GetTarget().GetName()))), x2, y, 0)
                        else:
                                pScienceScanWindow.AddChild(App.TGParagraph_CreateW(App.TGString("None")), x2, y, 0)

                        
        
        # rebuild Pane
        pScienceMenu.AddChild(None)


def CreateSciencePane():
        global pScienceMenu, pScienceScanWindow
        # Create the Scan output Window:
        
        pSciencePane = pScienceMenu.GetParent()
        pScienceScanWindow = App.STStylizedWindow_CreateW("StylizedWindow", "NormalStyle", App.TGString("Scan output"))
        pScienceScanWindow.SetFixedSize(0.4, 0.5)
                
        pScienceScanWindow.InteriorChangedSize()
        pSciencePane.AddChild(pScienceScanWindow, 0.6, 0.0, 0)
        
        # rebuild Pane
        pScienceMenu.AddChild(None)


def MarinesSay(SayString, Person = "Brex"):
        global MarinesDatabase, g_pBrex, pBridge
        g_pFelix = App.CharacterClass_GetObject(pBridge, "Tactical") 

        if (Person == "Felix"):
            Person = g_pFelix
        else:
            Person = g_pBrex
        pSequence = App.TGSequence_Create()
        pSequence.AppendAction(App.CharacterAction_Create(Person, App.CharacterAction.AT_SAY_LINE, SayString, None, 0, MarinesDatabase))
        pSequence.Play()    


# oh found it - here we create the Buttons :)
if (pBrexMenu != None):
        pMasterButtonMarines = App.STMenu_CreateW(App.TGString("Marines"))
        pBrexMenu.PrependChild(pMasterButtonMarines)
    
        pMasterButtonTransfer = App.STMenu_CreateW(App.TGString("Transfer"))
        pMasterButtonMarines.PrependChild(pMasterButtonTransfer)
        
        event = Lib.Ambiguity.getEvent("ET_CAPTURE")
        g_pBrex.AddPythonFuncHandlerForInstance(event, __name__ + ".Capture")
        pButtonCapture = QuickBattle.QuickBattle.CreateBridgeMenuButton(App.TGString('Capture'), event, 0, g_pBrex)
        pMasterButtonMarines.PrependChild(pButtonCapture)

	event = Lib.Ambiguity.getEvent("SELECT_TROOPS")
	g_pBrex.AddPythonFuncHandlerForInstance(event, __name__ + ".SelectTroops")
	pButtonSelectTroops = QuickBattle.QuickBattle.CreateBridgeMenuButton(App.TGString('Troops: ' + str(p_ActiveTroops)), event, 0, g_pBrex)
	pMasterButtonMarines.PrependChild(pButtonSelectTroops)

        event = Lib.Ambiguity.getEvent("RECALL_TROOPS")
        g_pBrex.AddPythonFuncHandlerForInstance(event, __name__ + ".RecallTroops")
        pButtonRecallTroops = QuickBattle.QuickBattle.CreateBridgeMenuButton(App.TGString("Recall Troops"), event, 0, g_pBrex)
        pMasterButtonMarines.PrependChild(pButtonRecallTroops)
        
        event = Lib.Ambiguity.getEvent("TRANSFER_GET")
        g_pBrex.AddPythonFuncHandlerForInstance(event, __name__ + ".TransferGet")
        pButtonTransferGet = QuickBattle.QuickBattle.CreateBridgeMenuButton(App.TGString("Get"), event, 0, g_pBrex)
        pMasterButtonTransfer.PrependChild(pButtonTransferGet)

        event = Lib.Ambiguity.getEvent("TRANSFER_TROOPS")
        g_pBrex.AddPythonFuncHandlerForInstance(event, __name__ + ".TransferTroops")
        pButtonTransferDonate = QuickBattle.QuickBattle.CreateBridgeMenuButton(App.TGString("Donate"), event, 0, g_pBrex)
        pMasterButtonTransfer.PrependChild(pButtonTransferDonate)
        
        event = Lib.Ambiguity.getEvent("RESCUE_ALL")
        g_pBrex.AddPythonFuncHandlerForInstance(event, __name__ + ".Rescue")
        pButtonRescue = QuickBattle.QuickBattle.CreateBridgeMenuButton(App.TGString("Rescue"), event, 0, g_pBrex)
        pMasterButtonTransfer.PrependChild(pButtonRescue)


# This Event Handler is for our Timer, how long the Troops will fight
App.TopWindow_GetTopWindow().AddPythonFuncHandlerForInstance(MARINES_FIGHT_TIMER, __name__ + ".EndBattle")
# And this is the for the Timer how long until turning Shields back on for Transfer
App.TopWindow_GetTopWindow().AddPythonFuncHandlerForInstance(TRANSFER_SHIELDON_TIMER, __name__ + ".TransferShieldsOn")
# When Player is scanning....
pScienceMenu.AddPythonFuncHandlerForInstance(App.ET_SCAN, __name__ + ".ScanInit")
# Scan Timer:
App.TopWindow_GetTopWindow().AddPythonFuncHandlerForInstance(SCAN_TIMER, __name__ + ".MarinesScan")

# Finally the Marine class, la voila: I know, normally you put a class in its own file, but since I don't want to create 1000 files (only 1000 lines in one file :P):
class Marineclass:
    def __init__(self, pShip):
        self.pShip = pShip
        self.NumEnemy = 0
        pCarrier = ftb.ShipManager.GetShip(pShip)
        if hasattr(pCarrier, "GetNumMarines"):
            self.NumMarines = pCarrier.GetNumMarines()
        else:
            self.NumMarines = int(round(pShip.GetHull().GetRadius() * 30, 0))

        if hasattr(pCarrier, "GetNumPeople"):
            self.NumPeople = pCarrier.GetNumPeople()
        else:
            self.NumPeople = int(round(pShip.GetHull().GetRadius() * 50, 0))
        
    def GetMarines(self):
        return self.NumMarines

    def SetMarines(self, NumMarines):
        self.NumMarines = NumMarines
        
    def GetPeople(self):
        return self.NumPeople
    
    def SetPeople(self, NumPeople):
        self.NumPeople = NumPeople
        
    def GetEnemyMarinesOnShip(self):
        return self.NumEnemy
    
    def SetEnemyMarinesOnShip(self, NumEnemy):
        self.NumEnemy = NumEnemy
